/*			
		Permission to use				 

  Sony Computer Entertainment supplies this lws2rsd software free 	   
  of charge to licensees along with the source code files.		 

  This lws2rsd software is experimental and no support of any kind is 	  
  available.							 

  The licensee is hereby granted permission to use, copy, modify, and	   
  distribute this lws2rsd software and documentation for any purpose. 	  
  Sony Computer Entertainment shall bear no responsibility for any 	  
  damage or loss sustained either directly or indirectly as a result of	   
  using this software. 						   

  Copyright 1997 by Sony Computer Entertainment Inc. All Rights Reserved. 

*/
#include <stdio.h>

#define	LW_MODEL	0
#define LW_BONE		1

typedef struct Keyframe {
	int				frameNo;

	Param			s;
	Param			r;
	Param			t;

	Param			s2;
	Param			r2;
	Param			t2;

	int				linearStatus;

	Scalar			tension;
	Scalar			bias;
	Scalar			continuity;
} Keyframe, *KeyframePtr;


typedef struct Object {
	struct Object	*parent;		// trick (ModelPtr)objPtr->pivot, (BonePtr)objPtr->strength;
	int				id;
	int				parentID;
	char			PLY[256];
	char			name[256];
	Matrix			mat;
	Matrix			tmp;			// for COD
	int				noofKeyframe;
	KeyframePtr		keyframe;
} Object, *ObjectPtr;


typedef struct Model {
	Object			obj;
	Param			pivot;
	Param			pivot2;
} Model, *ModelPtr;


typedef struct Bone {
	Object			obj;
	Param			restPosition;	// bone start position
	Param			restDirection;	// bone direction
	Scalar			restLength;
	int				scaleStrength;
	Scalar			strength;

	Param			restPosition2;
	Param			restDirection2;
	Scalar			restLength2;
	int				scaleStrength2;
	Scalar			strength2;
//	Param			pivot2;

	Scalar			radius;
	Vector3			direction;

} Bone, *BonePtr;

#ifndef LW
void OpenLW( void );
void CloseLW( void );
void FreeBones( void );
void FreeModels( void );
int GetBoneRestPosition( char *buffer, BonePtr bone );
int GetBoneRestDirection( char *buffer, BonePtr bone );
int GetBoneRestLength( char *buffer, BonePtr bone );
int GetScaleBoneStrength( char *buffer, BonePtr bone );
int GetBoneStrength( char *buffer, BonePtr bone );
BonePtr NewBone( void );
ModelPtr NewModel( void );
int GetParentObject( char *buffer, ObjectPtr obj, int offset );
int GetObjectName( char *buffer, ObjectPtr obj, int type );
int GetPivotPoint( char *buffer, ModelPtr model );
int GetNumberOfChannel( FILE *fp, char *buffer, int *noofChannel );
int GetNumberOfKeyframe( FILE *fp, char *buffer, int *noofKeyframe );
int GetKeyframe9( FILE *fp, char *buffer, 
	Scalar *tx, Scalar *ty, Scalar *tz, 
	Scalar *rx, Scalar *ry, Scalar *rz, 
	Scalar *sx, Scalar *sy, Scalar *sz, 
	int *frameNo,
	int *linearStatus, 
	Scalar *tension,
	Scalar *bias,
	Scalar *continuity );
int GetKeyframes( FILE *fp, char *buffer, ObjectPtr obj );
int LoadBone( FILE *fp, char *buffer, BonePtr bone );
int LoadModel( FILE *fp, char *buffer, ModelPtr model );
int MasterParser( FILE *fp, char *buffer );
void LW2PS( Scalar scaleLw2Ps );
#endif // LW
