/*			
		Permission to use				 

  Sony Computer Entertainment supplies this lws2rsd software free 	   
  of charge to licensees along with the source code files.		 

  This lws2rsd software is experimental and no support of any kind is 	  
  available.							 

  The licensee is hereby granted permission to use, copy, modify, and	   
  distribute this lws2rsd software and documentation for any purpose. 	  
  Sony Computer Entertainment shall bear no responsibility for any 	  
  damage or loss sustained either directly or indirectly as a result of	   
  using this software. 						   

  Copyright 1997 by Sony Computer Entertainment Inc. All Rights Reserved. 

*/																					

#include <stdio.h>
#include <stdlib.h>

#include "vecmat.h"
#include "LW.h"

#define MOT_VERSION			"# ID\n@MOT970401\n"
#define ANIMATION_TYPE		"# Animation Type\nCOORDINATE\n"

int SaveMOT( char *MOTfileName, int noofBone, BonePtr bone, int totalFrame )
{
	FILE		*fp;
	ObjectPtr	obj;
	Param		r, t;
	const int	noofIndex = noofBone;
	const int	noofSeq = 1;
	int			noofKeyframe;
	int			i, index, k;
	int			delta;
	int			globalCount;


	if ( !(fp = fopen( MOTfileName, "w" )) ) {
		fprintf( stderr, "Could not open MOT file\n" );
		exit( 1 );
	}

	// tmp total frame
	
	for ( globalCount = 0, i = 0; i < noofBone; i++ )
		if ( bone[i].obj.noofKeyframe > 1 )
			globalCount++;	// count number of moved objects

	globalCount *= 2;		// *2, since rot and param are separeted

	/******************	MOT Header ********************/
	fprintf( fp, MOT_VERSION );
	fprintf( fp, ANIMATION_TYPE );
	fprintf( fp, "# Number of Index\n%d\n", globalCount );


	/*********** Index, Number of Sequence ************/
	//					Sequence Header
	// for rotation
	for ( index = 0; index < noofBone; index++ ) {
		noofKeyframe = bone[index].obj.noofKeyframe;

		if ( noofKeyframe < 2 )
			continue;

		fprintf( fp, "# Index, Number of Sequence, DUMY\n%-6d%6d DUMY\n", index, noofSeq );
		fprintf( fp, "# Sequence Header\n" );
//		fprintf( fp, "START ROT%d   %d 0x01\n", index, bone[index].obj.keyframe[noofKeyframe-1].frameNo+1 );
		fprintf( fp, "START ROT%d   0x01\n", index );
	}

	// for translation
	for ( index = 0; index < noofBone; index++ ) {
		noofKeyframe = bone[index].obj.noofKeyframe;

		if ( noofKeyframe < 2 )
			continue;

		fprintf( fp, "# Index, Number of Sequence, DUMY\n%-6d%6d DUMY\n", index, noofSeq );
		fprintf( fp, "# Sequence Header\n" );
//		fprintf( fp, "START TRANS%d %d 0x01\n", index, bone[index].obj.keyframe[noofKeyframe-1].frameNo+1 );
		fprintf( fp, "START TRANS%d 0x01\n", index  );
	}

	/************* Sequence Control Info. **************/
	// for rotation
	globalCount = 0;		// for Parameters Info. index
	fprintf( fp, "#Sequence Control\n" );

	for ( index = 0; index < noofBone; index++ ) {
		obj = &bone[index].obj;

		if ( obj->noofKeyframe < 2 )
			continue;

		fprintf( fp, "ROT%d\n", index );
		for ( k = 0; k < obj->noofKeyframe; k++ ) {
			if ( k == 0 )
				delta = 1;
			else
				delta = obj->keyframe[k].frameNo - obj->keyframe[k-1].frameNo;

			fprintf( fp, "SEQ %d ps0r1t0 %d\n", delta, globalCount );
			globalCount++;
		}
//		fprintf( fp, "END 0x02\n" );

		fprintf( fp, "GOTO ROT%d 0x01 0x01\n", index );
		fprintf( fp, "END 0x00\n" );

	}

	// for translation
	globalCount = 0;		// for Parameters Info. index
	fprintf( fp, "#Sequence Control\n" );

	for ( index = 0; index < noofBone; index++ ) {
		obj = &bone[index].obj;

		if ( obj->noofKeyframe < 2 )
			continue;

		fprintf( fp, "TRANS%d\n", index );
		for ( k = 0; k < obj->noofKeyframe; k++ ) {
			if ( k == 0 )
				delta = 1;
			else
				delta = obj->keyframe[k].frameNo - obj->keyframe[k-1].frameNo;

			fprintf( fp, "SEQ %d ps0r0t1 %d\n", delta, globalCount );
			globalCount++;
		}
//		fprintf( fp, "END 0x02\n" );

		fprintf( fp, "GOTO TRANS%d 0x01 0x01\n", index );
		fprintf( fp, "END 0x00\n" );
	}

	/***************** Parameters Info. ****************/
	// for rotation
	fprintf( fp, "#Animation Packet Type\n" );
	fprintf( fp, "TYPE ps0r1t0\n" );
	for ( index = 0; index < noofBone; index++ ) {
		obj = &bone[index].obj;

		if ( obj->noofKeyframe < 2 )
			continue;

		fprintf( fp, "#****************** %d *****************\n", index );

		for ( k = 0; k < obj->noofKeyframe; k++ ) {
			r = obj->keyframe[k].r2;
			r = RADtoDEG( &r );

			fprintf( fp, "#*	%f		%f		%f\n", r.x, r.y, r.z );

			r.x *= (4096 / 360);
			r.y *= (4096 / 360);
			r.z *= (4096 / 360);

			fprintf( fp, "%d		%d		%d\n", (int)r.x, (int)r.y, (int)r.z );
		}
	}

	// for translation
	fprintf( fp, "TYPE ps0r0t1\n" );
	for ( index = 0; index < noofBone; index++ ) {
		obj = &bone[index].obj;

		if ( obj->noofKeyframe < 2 )
			continue;

		fprintf( fp, "#****************** %d *****************\n", index );

		for ( k = 0; k < obj->noofKeyframe; k++ ) {
			t = obj->keyframe[k].t2;
			fprintf( fp, "%d		%d		%d\n", (int)t.x, (int)t.y, (int)t.z );
		}
	}

	return 0;
}
